diff --git a/benchtests/Makefile b/benchtests/Makefile
index 4fb9bae023..c3e281f076 100644
--- a/benchtests/Makefile
+++ b/benchtests/Makefile
@@ -32,6 +32,8 @@ bench-math := \
   atan2 \
   atanh \
   cbrt \
+  ceil \
+  ceilf \
   cos \
   cosf \
   cosh \
@@ -44,6 +46,8 @@ bench-math := \
   exp2f \
   expf \
   expm1 \
+  floor \
+  floorf \
   fmax \
   fmaxf \
   fmin \
@@ -68,10 +72,17 @@ bench-math := \
   logb \
   logbf \
   logf \
+  llrint \
+  llrintf \
+  lrint \
+  lrintf \
   modf \
+  nearbyint \
+  nearbyintf \
   pow \
   powf \
   rint \
+  rintf \
   roundeven \
   roundevenf \
   sin \
diff --git a/benchtests/ceil-inputs b/benchtests/ceil-inputs
new file mode 100644
index 0000000000..49ff407a6a
--- /dev/null
+++ b/benchtests/ceil-inputs
@@ -0,0 +1,22 @@
+## args: double
+## ret: double
+## includes: math.h
+0.0
+-0.0
+0.001
+-0.001
+0.5
+-0.5
+0.999
+-0.999
+1.0
+-1.0
+1.001
+-1.001
+123.5
+-123.5
+12345.1
+-1000000.1
+1e15
+-1e30
+1e200
diff --git a/benchtests/ceilf-inputs b/benchtests/ceilf-inputs
new file mode 100644
index 0000000000..c37c5dacba
--- /dev/null
+++ b/benchtests/ceilf-inputs
@@ -0,0 +1,21 @@
+## args: float
+## ret: float
+## includes: math.h
+0.0f
+-0.0f
+0.001f
+-0.001f
+0.5f
+-0.5f
+0.999f
+-0.999f
+1.0f
+-1.0f
+1.001f
+-1.001f
+123.5f
+-123.5f
+12345.1f
+-1000000.5f
+1e15f
+-1e30f
diff --git a/benchtests/floor-inputs b/benchtests/floor-inputs
new file mode 100644
index 0000000000..49ff407a6a
--- /dev/null
+++ b/benchtests/floor-inputs
@@ -0,0 +1,22 @@
+## args: double
+## ret: double
+## includes: math.h
+0.0
+-0.0
+0.001
+-0.001
+0.5
+-0.5
+0.999
+-0.999
+1.0
+-1.0
+1.001
+-1.001
+123.5
+-123.5
+12345.1
+-1000000.1
+1e15
+-1e30
+1e200
diff --git a/benchtests/floorf-inputs b/benchtests/floorf-inputs
new file mode 100644
index 0000000000..c37c5dacba
--- /dev/null
+++ b/benchtests/floorf-inputs
@@ -0,0 +1,21 @@
+## args: float
+## ret: float
+## includes: math.h
+0.0f
+-0.0f
+0.001f
+-0.001f
+0.5f
+-0.5f
+0.999f
+-0.999f
+1.0f
+-1.0f
+1.001f
+-1.001f
+123.5f
+-123.5f
+12345.1f
+-1000000.5f
+1e15f
+-1e30f
diff --git a/benchtests/llrint-inputs b/benchtests/llrint-inputs
new file mode 100644
index 0000000000..49ff407a6a
--- /dev/null
+++ b/benchtests/llrint-inputs
@@ -0,0 +1,22 @@
+## args: double
+## ret: double
+## includes: math.h
+0.0
+-0.0
+0.001
+-0.001
+0.5
+-0.5
+0.999
+-0.999
+1.0
+-1.0
+1.001
+-1.001
+123.5
+-123.5
+12345.1
+-1000000.1
+1e15
+-1e30
+1e200
diff --git a/benchtests/llrintf-inputs b/benchtests/llrintf-inputs
new file mode 100644
index 0000000000..c37c5dacba
--- /dev/null
+++ b/benchtests/llrintf-inputs
@@ -0,0 +1,21 @@
+## args: float
+## ret: float
+## includes: math.h
+0.0f
+-0.0f
+0.001f
+-0.001f
+0.5f
+-0.5f
+0.999f
+-0.999f
+1.0f
+-1.0f
+1.001f
+-1.001f
+123.5f
+-123.5f
+12345.1f
+-1000000.5f
+1e15f
+-1e30f
diff --git a/benchtests/lrint-inputs b/benchtests/lrint-inputs
new file mode 100644
index 0000000000..49ff407a6a
--- /dev/null
+++ b/benchtests/lrint-inputs
@@ -0,0 +1,22 @@
+## args: double
+## ret: double
+## includes: math.h
+0.0
+-0.0
+0.001
+-0.001
+0.5
+-0.5
+0.999
+-0.999
+1.0
+-1.0
+1.001
+-1.001
+123.5
+-123.5
+12345.1
+-1000000.1
+1e15
+-1e30
+1e200
diff --git a/benchtests/lrintf-inputs b/benchtests/lrintf-inputs
new file mode 100644
index 0000000000..c37c5dacba
--- /dev/null
+++ b/benchtests/lrintf-inputs
@@ -0,0 +1,21 @@
+## args: float
+## ret: float
+## includes: math.h
+0.0f
+-0.0f
+0.001f
+-0.001f
+0.5f
+-0.5f
+0.999f
+-0.999f
+1.0f
+-1.0f
+1.001f
+-1.001f
+123.5f
+-123.5f
+12345.1f
+-1000000.5f
+1e15f
+-1e30f
diff --git a/benchtests/nearbyint-inputs b/benchtests/nearbyint-inputs
new file mode 100644
index 0000000000..49ff407a6a
--- /dev/null
+++ b/benchtests/nearbyint-inputs
@@ -0,0 +1,22 @@
+## args: double
+## ret: double
+## includes: math.h
+0.0
+-0.0
+0.001
+-0.001
+0.5
+-0.5
+0.999
+-0.999
+1.0
+-1.0
+1.001
+-1.001
+123.5
+-123.5
+12345.1
+-1000000.1
+1e15
+-1e30
+1e200
diff --git a/benchtests/nearbyintf-inputs b/benchtests/nearbyintf-inputs
new file mode 100644
index 0000000000..c37c5dacba
--- /dev/null
+++ b/benchtests/nearbyintf-inputs
@@ -0,0 +1,21 @@
+## args: float
+## ret: float
+## includes: math.h
+0.0f
+-0.0f
+0.001f
+-0.001f
+0.5f
+-0.5f
+0.999f
+-0.999f
+1.0f
+-1.0f
+1.001f
+-1.001f
+123.5f
+-123.5f
+12345.1f
+-1000000.5f
+1e15f
+-1e30f
diff --git a/benchtests/rintf-inputs b/benchtests/rintf-inputs
new file mode 100644
index 0000000000..f7c6f06789
--- /dev/null
+++ b/benchtests/rintf-inputs
@@ -0,0 +1,7 @@
+## args: float
+## ret: float
+## includes: math.h
+78.5
+-78.5
+4503599627370497.0
+-4503599627370497.0